<?php

namespace WireDAV\Auth;

use Sabre\DAV\Auth\Backend\AbstractDigest;
use PDO;

class SQLAuthBackend extends AbstractDigest
{
    private PDO $pdo;

    /**
     * @param PDO $pdo A PDO instance connected to your DB
     */
    public function __construct(PDO $pdo)
    {
        $this->pdo = $pdo;
    }

    /**
     * This method must return the MD5 digest hash for the user in the format:
     * MD5(username:realm:password)
     * 
     * @param string $realm
     * @param string $username
     * @return string|false The hash or false if user not found
     */
    public function getDigestHash($realm, $username)
    {
        $stmt = $this->pdo->prepare('SELECT digesta1 FROM users WHERE username = ?');
        $stmt->execute([$username]);
        $hash = $stmt->fetchColumn();
        return $hash ?: false;
    }
}

